'wsptones_to_dat_stereo.bas
'df6nm 120922
'reads wsptones.txt containing output from WSPR.EXE
'generates WSPR.DAT or WSPR_2CH.DAT

'usage:
'wsptones_to_dat.exe [oversampling factor]
'default oversampling = 256 (samples per symbol)
'use negative oversampling (-256) to generate IQ stereo (quiet right channel)
 
nsm = VAL(COMMAND$)
IF nsm = 0 THEN nsm = 256 'oversampling
IF nsm < 0 THEN stereo = 1:nsm =-nsm

nm = 162
DIM nf(nm - 1)
         
OPEN "wsptones.txt" FOR INPUT AS 1
FOR n = 0 TO nm - 1
 LINE INPUT #1, wt$
 nf(n) = VAL(MID$(wt$, 6, 1))
NEXT n
CLOSE 1

pi2! = 8! * ATN(1)
a! = 32768! * 6 / 8
file$="wspr.dat"
if stereo then file$="wspr_2ch.dat"
OPEN file$ FOR OUTPUT AS 2
FOR n = 0 TO nm - 1
 FOR ns = 0 TO nsm - 1
  phi! = phi! - pi2! * (nf(n) - 1.5) / nsm
  re! = a! * COS(phi!)
  im! = a! * SIN(phi!)
  PRINT #2, MKI$(re!); MKI$(im!);
  IF stereo THEN PRINT #2, MKI$(0); MKI$(0);
 NEXT ns
 PRINT
NEXT n
CLOSE 2

